diff --git a/compiler/types/Unify.lhs b/compiler/types/Unify.lhs
index 8d1beb6..767459c 100644
--- a/compiler/types/Unify.lhs
+++ b/compiler/types/Unify.lhs
@@ -3,23 +3,17 @@
 %
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module Unify ( 
-	-- Matching of types: 
-	--	the "tc" prefix indicates that matching always
-	--	respects newtypes (rather than looking through them)
-	tcMatchTy, tcMatchTys, tcMatchTyX, 
-	ruleMatchTyX, tcMatchPreds, 
+        -- Matching of types: 
+        --      the "tc" prefix indicates that matching always
+        --      respects newtypes (rather than looking through them)
+        tcMatchTy, tcMatchTys, tcMatchTyX, 
+        ruleMatchTyX, tcMatchPreds, 
 
-	MatchEnv(..), matchList, 
+        MatchEnv(..), matchList, 
 
-	typesCantMatch,
+        typesCantMatch,
 
         -- Side-effect free unification
         tcUnifyTys, BindFlag(..),
@@ -46,9 +40,9 @@ import Control.Applicative (Applicative(..))
 
 
 %************************************************************************
-%*									*
-		Matching
-%*									*
+%*                                                                      *
+                Matching
+%*                                                                      *
 %************************************************************************
 
 
@@ -58,7 +52,7 @@ Matching is much tricker than you might think.
    which are given to us explicitly.
 
 2. We want to match in the presence of foralls; 
-	e.g 	(forall a. t1) ~ (forall b. t2)
+        e.g     (forall a. t1) ~ (forall b. t2)
 
    That is what the RnEnv2 is for; it does the alpha-renaming
    that makes it as if a and b were the same variable.
@@ -68,7 +62,7 @@ Matching is much tricker than you might think.
 
 3. We must be careful not to bind a template type variable to a
    locally bound variable.  E.g.
-	(forall a. x) ~ (forall b. b)
+        (forall a. x) ~ (forall b. b)
    where x is the template type variable.  Then we do not want to
    bind x to a/b!  This is a kind of occurs check.
    The necessary locals accumulate in the RnEnv2.
@@ -76,61 +70,61 @@ Matching is much tricker than you might think.
 
 \begin{code}
 data MatchEnv
-  = ME	{ me_tmpls :: VarSet	-- Template variables
- 	, me_env   :: RnEnv2	-- Renaming envt for nested foralls
-	}			--   In-scope set includes template variables
+  = ME  { me_tmpls :: VarSet    -- Template variables
+        , me_env   :: RnEnv2    -- Renaming envt for nested foralls
+        }                       --   In-scope set includes template variables
     -- Nota Bene: MatchEnv isn't specific to Types.  It is used
     --            for matching terms and coercions as well as types
 
-tcMatchTy :: TyVarSet		-- Template tyvars
-	  -> Type		-- Template
-	  -> Type		-- Target
-	  -> Maybe TvSubst	-- One-shot; in principle the template
-				-- variables could be free in the target
+tcMatchTy :: TyVarSet           -- Template tyvars
+          -> Type               -- Template
+          -> Type               -- Target
+          -> Maybe TvSubst      -- One-shot; in principle the template
+                                -- variables could be free in the target
 
 tcMatchTy tmpls ty1 ty2
   = case match menv emptyTvSubstEnv ty1 ty2 of
-	Just subst_env -> Just (TvSubst in_scope subst_env)
-	Nothing	       -> Nothing
+        Just subst_env -> Just (TvSubst in_scope subst_env)
+        Nothing        -> Nothing
   where
     menv     = ME { me_tmpls = tmpls, me_env = mkRnEnv2 in_scope }
     in_scope = mkInScopeSet (tmpls `unionVarSet` tyVarsOfType ty2)
-	-- We're assuming that all the interesting 
-	-- tyvars in tys1 are in tmpls
+        -- We're assuming that all the interesting 
+        -- tyvars in tys1 are in tmpls
 
-tcMatchTys :: TyVarSet		-- Template tyvars
-	   -> [Type]		-- Template
-	   -> [Type]		-- Target
-	   -> Maybe TvSubst	-- One-shot; in principle the template
-				-- variables could be free in the target
+tcMatchTys :: TyVarSet          -- Template tyvars
+           -> [Type]            -- Template
+           -> [Type]            -- Target
+           -> Maybe TvSubst     -- One-shot; in principle the template
+                                -- variables could be free in the target
 
 tcMatchTys tmpls tys1 tys2
   = case match_tys menv emptyTvSubstEnv tys1 tys2 of
-	Just subst_env -> Just (TvSubst in_scope subst_env)
-	Nothing	       -> Nothing
+        Just subst_env -> Just (TvSubst in_scope subst_env)
+        Nothing        -> Nothing
   where
     menv     = ME { me_tmpls = tmpls, me_env = mkRnEnv2 in_scope }
     in_scope = mkInScopeSet (tmpls `unionVarSet` tyVarsOfTypes tys2)
-	-- We're assuming that all the interesting 
-	-- tyvars in tys1 are in tmpls
+        -- We're assuming that all the interesting 
+        -- tyvars in tys1 are in tmpls
 
 -- This is similar, but extends a substitution
-tcMatchTyX :: TyVarSet 		-- Template tyvars
-	   -> TvSubst		-- Substitution to extend
-	   -> Type		-- Template
-	   -> Type		-- Target
-	   -> Maybe TvSubst
+tcMatchTyX :: TyVarSet          -- Template tyvars
+           -> TvSubst           -- Substitution to extend
+           -> Type              -- Template
+           -> Type              -- Target
+           -> Maybe TvSubst
 tcMatchTyX tmpls (TvSubst in_scope subst_env) ty1 ty2
   = case match menv subst_env ty1 ty2 of
-	Just subst_env -> Just (TvSubst in_scope subst_env)
-	Nothing	       -> Nothing
+        Just subst_env -> Just (TvSubst in_scope subst_env)
+        Nothing        -> Nothing
   where
     menv = ME {me_tmpls = tmpls, me_env = mkRnEnv2 in_scope}
 
 tcMatchPreds
-	:: [TyVar]			-- Bind these
-	-> [PredType] -> [PredType]
-   	-> Maybe TvSubstEnv
+        :: [TyVar]                      -- Bind these
+        -> [PredType] -> [PredType]
+        -> Maybe TvSubstEnv
 tcMatchPreds tmpls ps1 ps2
   = matchList (match menv) emptyTvSubstEnv ps1 ps2
   where
@@ -139,46 +133,46 @@ tcMatchPreds tmpls ps1 ps2
 
 -- This one is called from the expression matcher, which already has a MatchEnv in hand
 ruleMatchTyX :: MatchEnv 
-	 -> TvSubstEnv		-- Substitution to extend
-	 -> Type		-- Template
-	 -> Type		-- Target
-	 -> Maybe TvSubstEnv
+         -> TvSubstEnv          -- Substitution to extend
+         -> Type                -- Template
+         -> Type                -- Target
+         -> Maybe TvSubstEnv
 
-ruleMatchTyX menv subst ty1 ty2 = match menv subst ty1 ty2	-- Rename for export
+ruleMatchTyX menv subst ty1 ty2 = match menv subst ty1 ty2      -- Rename for export
 \end{code}
 
 Now the internals of matching
 
 \begin{code}
-match :: MatchEnv	-- For the most part this is pushed downwards
-      -> TvSubstEnv 	-- Substitution so far:
-			--   Domain is subset of template tyvars
-			--   Free vars of range is subset of 
-			--	in-scope set of the RnEnv2
-      -> Type -> Type	-- Template and target respectively
+match :: MatchEnv       -- For the most part this is pushed downwards
+      -> TvSubstEnv     -- Substitution so far:
+                        --   Domain is subset of template tyvars
+                        --   Free vars of range is subset of 
+                        --      in-scope set of the RnEnv2
+      -> Type -> Type   -- Template and target respectively
       -> Maybe TvSubstEnv
 
 match menv subst ty1 ty2 | Just ty1' <- coreView ty1 = match menv subst ty1' ty2
-			 | Just ty2' <- coreView ty2 = match menv subst ty1 ty2'
+                         | Just ty2' <- coreView ty2 = match menv subst ty1 ty2'
 
 match menv subst (TyVarTy tv1) ty2
-  | Just ty1' <- lookupVarEnv subst tv1'	-- tv1' is already bound
+  | Just ty1' <- lookupVarEnv subst tv1'        -- tv1' is already bound
   = if eqTypeX (nukeRnEnvL rn_env) ty1' ty2
-	-- ty1 has no locally-bound variables, hence nukeRnEnvL
+        -- ty1 has no locally-bound variables, hence nukeRnEnvL
     then Just subst
-    else Nothing	-- ty2 doesn't match
+    else Nothing        -- ty2 doesn't match
 
   | tv1' `elemVarSet` me_tmpls menv
   = if any (inRnEnvR rn_env) (varSetElems (tyVarsOfType ty2))
-    then Nothing	-- Occurs check
+    then Nothing        -- Occurs check
     else do { subst1 <- match_kind menv subst (tyVarKind tv1) (typeKind ty2)
-			-- Note [Matching kinds]
-	    ; return (extendVarEnv subst1 tv1' ty2) }
+                        -- Note [Matching kinds]
+            ; return (extendVarEnv subst1 tv1' ty2) }
 
-   | otherwise	-- tv1 is not a template tyvar
+   | otherwise  -- tv1 is not a template tyvar
    = case ty2 of
-	TyVarTy tv2 | tv1' == rnOccR rn_env tv2 -> Just subst
-	_                                       -> Nothing
+        TyVarTy tv2 | tv1' == rnOccR rn_env tv2 -> Just subst
+        _                                       -> Nothing
   where
     rn_env = me_env menv
     tv1' = rnOccL rn_env tv1
@@ -186,7 +180,7 @@ match menv subst (TyVarTy tv1) ty2
 match menv subst (ForAllTy tv1 ty1) (ForAllTy tv2 ty2) 
   = do { subst' <- match_kind menv subst (tyVarKind tv1) (tyVarKind tv2)
        ; match menv' subst' ty1 ty2 }
-  where		-- Use the magic of rnBndr2 to go under the binders
+  where         -- Use the magic of rnBndr2 to go under the binders
     menv' = menv { me_env = rnBndr2 (me_env menv) tv1 tv2 }
 
 match menv subst (TyConApp tc1 tys1) (TyConApp tc2 tys2) 
@@ -196,7 +190,7 @@ match menv subst (FunTy ty1a ty1b) (FunTy ty2a ty2b)
        ; match menv subst' ty1b ty2b }
 match menv subst (AppTy ty1a ty1b) ty2
   | Just (ty2a, ty2b) <- repSplitAppTy_maybe ty2
-	-- 'repSplit' used because the tcView stuff is done above
+        -- 'repSplit' used because the tcView stuff is done above
   = do { subst' <- match menv subst ty1a ty2a
        ; match menv subst' ty1b ty2b }
 
@@ -236,51 +230,51 @@ match_tys menv subst tys1 tys2 = matchList (match menv) subst tys1 tys2
 
 --------------
 matchList :: (env -> a -> b -> Maybe env)
-	   -> env -> [a] -> [b] -> Maybe env
+           -> env -> [a] -> [b] -> Maybe env
 matchList _  subst []     []     = Just subst
 matchList fn subst (a:as) (b:bs) = do { subst' <- fn subst a b
-				      ; matchList fn subst' as bs }
+                                      ; matchList fn subst' as bs }
 matchList _  _     _      _      = Nothing
 \end{code}
 
 
 %************************************************************************
-%*									*
-		GADTs
-%*									*
+%*                                                                      *
+                GADTs
+%*                                                                      *
 %************************************************************************
 
 Note [Pruning dead case alternatives]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-Consider	data T a where
-		   T1 :: T Int
-		   T2 :: T a
+Consider        data T a where
+                   T1 :: T Int
+                   T2 :: T a
 
-		newtype X = MkX Int
-		newtype Y = MkY Char
+                newtype X = MkX Int
+                newtype Y = MkY Char
 
-		type family F a
-		type instance F Bool = Int
+                type family F a
+                type instance F Bool = Int
 
-Now consider	case x of { T1 -> e1; T2 -> e2 }
+Now consider    case x of { T1 -> e1; T2 -> e2 }
 
 The question before the house is this: if I know something about the type
 of x, can I prune away the T1 alternative?
 
 Suppose x::T Char.  It's impossible to construct a (T Char) using T1, 
-	Answer = YES we can prune the T1 branch (clearly)
+        Answer = YES we can prune the T1 branch (clearly)
 
 Suppose x::T (F a), where 'a' is in scope.  Then 'a' might be instantiated
 to 'Bool', in which case x::T Int, so
-	ANSWER = NO (clearly)
+        ANSWER = NO (clearly)
 
 Suppose x::T X.  Then *in Haskell* it's impossible to construct a (non-bottom) 
 value of type (T X) using T1.  But *in FC* it's quite possible.  The newtype
 gives a coercion
-	CoX :: X ~ Int
+        CoX :: X ~ Int
 So (T CoX) :: T X ~ T Int; hence (T1 `cast` sym (T CoX)) is a non-bottom value
 of type (T X) constructed with T1.  Hence
-	ANSWER = NO we can't prune the T1 branch (surprisingly)
+        ANSWER = NO we can't prune the T1 branch (surprisingly)
 
 Furthermore, this can even happen; see Trac #1251.  GHC's newtype-deriving
 mechanism uses a cast, just as above, to move from one dictionary to another,
@@ -291,9 +285,9 @@ non-bottom value of type (T Y) using T1.  That's because we can get
 from Y to Char, but not to Int.
 
 
-Here's a related question.  	data Eq a b where EQ :: Eq a a
+Here's a related question.      data Eq a b where EQ :: Eq a a
 Consider
-	case x of { EQ -> ... }
+        case x of { EQ -> ... }
 
 Suppose x::Eq Int Char.  Is the alternative dead?  Clearly yes.
 
@@ -301,7 +295,7 @@ What about x::Eq Int a, in a context where we have evidence that a~Char.
 Then again the alternative is dead.   
 
 
-			Summary
+                        Summary
 
 We are really doing a test for unsatisfiability of the type
 constraints implied by the match. And that is clearly, in general, a
@@ -321,40 +315,40 @@ typesCantMatch prs = any (\(s,t) -> cant_match s t) prs
   where
     cant_match :: Type -> Type -> Bool
     cant_match t1 t2
-	| Just t1' <- coreView t1 = cant_match t1' t2
-	| Just t2' <- coreView t2 = cant_match t1 t2'
+        | Just t1' <- coreView t1 = cant_match t1' t2
+        | Just t2' <- coreView t2 = cant_match t1 t2'
 
     cant_match (FunTy a1 r1) (FunTy a2 r2)
-	= cant_match a1 a2 || cant_match r1 r2
+        = cant_match a1 a2 || cant_match r1 r2
 
     cant_match (TyConApp tc1 tys1) (TyConApp tc2 tys2)
-	| isDistinctTyCon tc1 && isDistinctTyCon tc2
-	= tc1 /= tc2 || typesCantMatch (zipEqual "typesCantMatch" tys1 tys2)
+        | isDistinctTyCon tc1 && isDistinctTyCon tc2
+        = tc1 /= tc2 || typesCantMatch (zipEqual "typesCantMatch" tys1 tys2)
 
     cant_match (FunTy {}) (TyConApp tc _) = isDistinctTyCon tc
     cant_match (TyConApp tc _) (FunTy {}) = isDistinctTyCon tc
-	-- tc can't be FunTyCon by invariant
+        -- tc can't be FunTyCon by invariant
 
     cant_match (AppTy f1 a1) ty2
-	| Just (f2, a2) <- repSplitAppTy_maybe ty2
-	= cant_match f1 f2 || cant_match a1 a2
+        | Just (f2, a2) <- repSplitAppTy_maybe ty2
+        = cant_match f1 f2 || cant_match a1 a2
     cant_match ty1 (AppTy f2 a2)
-	| Just (f1, a1) <- repSplitAppTy_maybe ty1
-	= cant_match f1 f2 || cant_match a1 a2
+        | Just (f1, a1) <- repSplitAppTy_maybe ty1
+        = cant_match f1 f2 || cant_match a1 a2
 
     cant_match (LitTy x) (LitTy y) = x /= y
 
     cant_match _ _ = False      -- Safe!
 
 -- Things we could add;
---	foralls
---	look through newtypes
---	take account of tyvar bindings (EQ example above)
+--      foralls
+--      look through newtypes
+--      take account of tyvar bindings (EQ example above)
 \end{code}
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
              Unification
 %*                                                                      *
 %************************************************************************
@@ -418,8 +412,8 @@ in these cases.
 
 \begin{code}
 tcUnifyTys :: (TyVar -> BindFlag)
-	   -> [Type] -> [Type]
-	   -> Maybe TvSubst	-- A regular one-shot (idempotent) substitution
+           -> [Type] -> [Type]
+           -> Maybe TvSubst     -- A regular one-shot (idempotent) substitution
 -- The two types may have common type variables, and indeed do so in the
 -- second call to tcUnifyTys in FunDeps.checkClsFD
 --
@@ -446,15 +440,15 @@ tcUnifyTysFG bind_fn tys1 tys2
   = initUM bind_fn $
     do { subst <- unifyList emptyTvSubstEnv tys1 tys2
 
-	-- Find the fixed point of the resulting non-idempotent substitution
+        -- Find the fixed point of the resulting non-idempotent substitution
         ; return (niFixTvSubst subst) }
 \end{code}
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
                 Non-idempotent substitution
-%*									*
+%*                                                                      *
 %************************************************************************
 
 Note [Non-idempotent substitution]
@@ -485,21 +479,21 @@ niSubstTvSet subst tvs
   = foldVarSet (unionVarSet . get) emptyVarSet tvs
   where
     get tv = case lookupVarEnv subst tv of
-	       Nothing -> unitVarSet tv
+               Nothing -> unitVarSet tv
                Just ty -> niSubstTvSet subst (tyVarsOfType ty)
 \end{code}
 
 %************************************************************************
-%*									*
-		The workhorse
-%*									*
+%*                                                                      *
+                The workhorse
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
-unify :: TvSubstEnv	-- An existing substitution to extend
-      -> Type -> Type 	-- Types to be unified, and witness of their equality
-      -> UM TvSubstEnv		-- Just the extended substitution, 
-				-- Nothing if unification failed
+unify :: TvSubstEnv     -- An existing substitution to extend
+      -> Type -> Type   -- Types to be unified, and witness of their equality
+      -> UM TvSubstEnv          -- Just the extended substitution, 
+                                -- Nothing if unification failed
 -- We do not require the incoming substitution to be idempotent,
 -- nor guarantee that the outgoing one is.  That's fixed up by
 -- the wrappers.
@@ -518,27 +512,27 @@ unify subst (TyConApp tyc1 tys1) (TyConApp tyc2 tys2)
   = unify_tys subst tys1 tys2
 
 unify subst (FunTy ty1a ty1b) (FunTy ty2a ty2b) 
-  = do	{ subst' <- unify subst ty1a ty2a
-	; unify subst' ty1b ty2b }
+  = do  { subst' <- unify subst ty1a ty2a
+        ; unify subst' ty1b ty2b }
 
-	-- Applications need a bit of care!
-	-- They can match FunTy and TyConApp, so use splitAppTy_maybe
-	-- NB: we've already dealt with type variables and Notes,
-	-- so if one type is an App the other one jolly well better be too
+        -- Applications need a bit of care!
+        -- They can match FunTy and TyConApp, so use splitAppTy_maybe
+        -- NB: we've already dealt with type variables and Notes,
+        -- so if one type is an App the other one jolly well better be too
 unify subst (AppTy ty1a ty1b) ty2
   | Just (ty2a, ty2b) <- repSplitAppTy_maybe ty2
-  = do	{ subst' <- unify subst ty1a ty2a
+  = do  { subst' <- unify subst ty1a ty2a
         ; unify subst' ty1b ty2b }
 
 unify subst ty1 (AppTy ty2a ty2b)
   | Just (ty1a, ty1b) <- repSplitAppTy_maybe ty1
-  = do	{ subst' <- unify subst ty1a ty2a
+  = do  { subst' <- unify subst ty1a ty2a
         ; unify subst' ty1b ty2b }
 
 unify subst (LitTy x) (LitTy y) | x == y = return subst
 
 unify _ _ _ = surelyApart
-	-- ForAlls??
+        -- ForAlls??
 
 ------------------------------
 unify_tys :: TvSubstEnv -> [Type] -> [Type] -> UM TvSubstEnv
@@ -550,11 +544,11 @@ unifyList subst orig_xs orig_ys
   where
     go subst []     []     = return subst
     go subst (x:xs) (y:ys) = do { subst' <- unify subst x y
-				; go subst' xs ys }
+                                ; go subst' xs ys }
     go _ _ _ = surelyApart
 
 ---------------------------------
-uVar :: TvSubstEnv	-- An existing substitution to extend
+uVar :: TvSubstEnv      -- An existing substitution to extend
      -> TyVar           -- Type variable to be unified
      -> Type            -- with this type
      -> UM TvSubstEnv
@@ -564,7 +558,7 @@ uVar subst tv1 ty
    case (lookupVarEnv subst tv1) of
      Just ty' -> unify subst ty' ty     -- Yes, call back into unify'
      Nothing  -> uUnrefined subst       -- No, continue
-			    tv1 ty ty
+                            tv1 ty ty
 
 uUnrefined :: TvSubstEnv          -- An existing substitution to extend
            -> TyVar               -- Type variable to be unified
@@ -576,13 +570,13 @@ uUnrefined :: TvSubstEnv          -- An existing substitution to extend
 
 uUnrefined subst tv1 ty2 ty2'
   | Just ty2'' <- tcView ty2'
-  = uUnrefined subst tv1 ty2 ty2''	-- Unwrap synonyms
-		-- This is essential, in case we have
-		--	type Foo a = a
-		-- and then unify a ~ Foo a
+  = uUnrefined subst tv1 ty2 ty2''      -- Unwrap synonyms
+                -- This is essential, in case we have
+                --      type Foo a = a
+                -- and then unify a ~ Foo a
 
 uUnrefined subst tv1 ty2 (TyVarTy tv2)
-  | tv1 == tv2		-- Same type variable
+  | tv1 == tv2          -- Same type variable
   = return subst
 
     -- Check to see whether tv2 is refined
@@ -596,8 +590,8 @@ uUnrefined subst tv1 ty2 (TyVarTy tv2)
 
            -- And then bind one or the other, 
            -- depending on which is bindable
-	   -- NB: unlike TcUnify we do not have an elaborate sub-kinding 
-	   --     story.  That is relevant only during type inference, and
+           -- NB: unlike TcUnify we do not have an elaborate sub-kinding 
+           --     story.  That is relevant only during type inference, and
            --     (I very much hope) is not relevant here.
        ; b1 <- tvBindFlag tv1
        ; b2 <- tvBindFlag tv2
@@ -607,50 +601,50 @@ uUnrefined subst tv1 ty2 (TyVarTy tv2)
            (BindMe, _)      -> return (extendVarEnv subst' tv1 ty2)
            (_, BindMe)      -> return (extendVarEnv subst' tv2 ty1) }
 
-uUnrefined subst tv1 ty2 ty2'	-- ty2 is not a type variable
+uUnrefined subst tv1 ty2 ty2'   -- ty2 is not a type variable
   | tv1 `elemVarSet` niSubstTvSet subst (tyVarsOfType ty2')
   = maybeApart subst                    -- Occurs check
                                         -- See Note [Fine-grained unification]
   | otherwise
   = do { subst' <- unify subst k1 k2
-       ; bindTv subst' tv1 ty2 }	-- Bind tyvar to the synonym if poss
+       ; bindTv subst' tv1 ty2 }        -- Bind tyvar to the synonym if poss
   where
     k1 = tyVarKind tv1
     k2 = typeKind ty2'
 
 bindTv :: TvSubstEnv -> TyVar -> Type -> UM TvSubstEnv
-bindTv subst tv ty	-- ty is not a type variable
+bindTv subst tv ty      -- ty is not a type variable
   = do  { b <- tvBindFlag tv
-	; case b of
-	    Skolem -> maybeApart subst -- See Note [Unification with skolems]
-	    BindMe -> return $ extendVarEnv subst tv ty
-	}
+        ; case b of
+            Skolem -> maybeApart subst -- See Note [Unification with skolems]
+            BindMe -> return $ extendVarEnv subst tv ty
+        }
 \end{code}
 
 %************************************************************************
-%*									*
-		Binding decisions
-%*									*
+%*                                                                      *
+                Binding decisions
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 data BindFlag 
-  = BindMe	-- A regular type variable
+  = BindMe      -- A regular type variable
 
-  | Skolem	-- This type variable is a skolem constant
-		-- Don't bind it; it only matches itself
+  | Skolem      -- This type variable is a skolem constant
+                -- Don't bind it; it only matches itself
 \end{code}
 
 
 %************************************************************************
-%*									*
-		Unification monad
-%*									*
+%*                                                                      *
+                Unification monad
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 newtype UM a = UM { unUM :: (TyVar -> BindFlag)
-		         -> UnifyResultM a }
+                         -> UnifyResultM a }
 
 instance Functor UM where
       fmap = liftM
@@ -663,7 +657,7 @@ instance Monad UM where
   return a = UM (\_tvs -> Unifiable a)
   fail _   = UM (\_tvs -> SurelyApart) -- failed pattern match
   m >>= k  = UM (\tvs -> case unUM m tvs of
-			   Unifiable v -> unUM (k v) tvs
+                           Unifiable v -> unUM (k v) tvs
                            MaybeApart v ->
                              case unUM (k v) tvs of
                                Unifiable v' -> MaybeApart v'
diff --git a/compiler/utils/BufWrite.hs b/compiler/utils/BufWrite.hs
index f85ea8e..f97d828 100644
--- a/compiler/utils/BufWrite.hs
+++ b/compiler/utils/BufWrite.hs
@@ -10,22 +10,16 @@
 --
 -----------------------------------------------------------------------------
 
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module BufWrite (
-	BufHandle(..),
-	newBufHandle,
-	bPutChar,
-	bPutStr,
-	bPutFS,
-	bPutFZS,
-	bPutLitString,
-	bFlush,
+        BufHandle(..),
+        newBufHandle,
+        bPutChar,
+        bPutStr,
+        bPutFS,
+        bPutFZS,
+        bPutLitString,
+        bFlush,
   ) where
 
 #include "HsVersions.h"
@@ -34,10 +28,10 @@ import FastString
 import FastTypes
 import FastMutInt
 
-import Control.Monad	( when )
+import Control.Monad    ( when )
 import Data.ByteString (ByteString)
 import qualified Data.ByteString.Unsafe as BS
-import Data.Char	( ord )
+import Data.Char        ( ord )
 import Foreign
 import Foreign.C.String
 import System.IO
@@ -45,8 +39,8 @@ import System.IO
 -- -----------------------------------------------------------------------------
 
 data BufHandle = BufHandle {-#UNPACK#-}!(Ptr Word8)
-			   {-#UNPACK#-}!FastMutInt
-			   Handle
+                           {-#UNPACK#-}!FastMutInt
+                           Handle
 
 newBufHandle :: Handle -> IO BufHandle
 newBufHandle hdl = do
@@ -66,11 +60,11 @@ STRICT2(bPutChar)
 bPutChar b@(BufHandle buf r hdl) c = do
   i <- readFastMutInt r
   if (i >= buf_size)
-	then do hPutBuf hdl buf buf_size
-		writeFastMutInt r 0
-		bPutChar b c
-	else do pokeElemOff buf i (fromIntegral (ord c) :: Word8)
-		writeFastMutInt r (i+1)
+        then do hPutBuf hdl buf buf_size
+                writeFastMutInt r 0
+                bPutChar b c
+        else do pokeElemOff buf i (fromIntegral (ord c) :: Word8)
+                writeFastMutInt r (i+1)
 
 bPutStr :: BufHandle -> String -> IO ()
 STRICT2(bPutStr)
@@ -78,14 +72,14 @@ bPutStr (BufHandle buf r hdl) str = do
   i <- readFastMutInt r
   loop str i
   where loop _ i | i `seq` False = undefined
-	loop "" i = do writeFastMutInt r i; return ()
-	loop (c:cs) i
-	   | i >= buf_size = do
-		hPutBuf hdl buf buf_size
-		loop (c:cs) 0
-	   | otherwise = do
-		pokeElemOff buf i (fromIntegral (ord c))
-		loop cs (i+1)
+        loop "" i = do writeFastMutInt r i; return ()
+        loop (c:cs) i
+           | i >= buf_size = do
+                hPutBuf hdl buf buf_size
+                loop (c:cs) 0
+           | otherwise = do
+                pokeElemOff buf i (fromIntegral (ord c))
+                loop cs (i+1)
   
 bPutFS :: BufHandle -> FastString -> IO ()
 bPutFS b fs = bPutBS b $ fastStringToByteString fs
@@ -114,14 +108,14 @@ bPutLitString b@(BufHandle buf r hdl) a len_ = a `seq` do
   let len = iBox len_
   i <- readFastMutInt r
   if (i+len) >= buf_size
-	then do hPutBuf hdl buf i
-		writeFastMutInt r 0
-		if (len >= buf_size) 
-		    then hPutBuf hdl a len
-		    else bPutLitString b a len_
-	else do
-		copyBytes (buf `plusPtr` i) a len
-		writeFastMutInt r (i+len)
+        then do hPutBuf hdl buf i
+                writeFastMutInt r 0
+                if (len >= buf_size) 
+                    then hPutBuf hdl a len
+                    else bPutLitString b a len_
+        else do
+                copyBytes (buf `plusPtr` i) a len
+                writeFastMutInt r (i+len)
 
 bFlush :: BufHandle -> IO ()
 bFlush (BufHandle buf r hdl) = do
